OpenVDB 11.0.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
LeafData< Fp8, CoordT, MaskT, LOG2DIM > Struct Template Reference

`#include <nanovdb/NanoVDB.h>`

Inheritance diagram for LeafData< Fp8, CoordT, MaskT, LOG2DIM >:

## Public Types
using | BaseT = LeafFnBase<CoordT, MaskT, LOG2DIM>
using | BuildType = Fp8
using | ArrayType = uint8_t
using | ValueType = float
using | FloatType = float

## Public Member Functions
float | getValue (uint32_t i) const
| LeafData ()=delete
| This class cannot be constructed or deleted.
| LeafData (const LeafData &)=delete
LeafData & | operator= (const LeafData &)=delete
| ~LeafData ()=delete
void | init (float min, float max, uint8_t bitWidth)
void | setOn (uint32_t offset)
float | getMin () const
| return the quantized minimum of the active values in this node
float | getMax () const
| return the quantized maximum of the active values in this node
float | getAvg () const
| return the quantized average of the active values in this node
float | getDev () const
| return the quantized standard deviation of the active values in this node
void | setMin (float min)
void | setMax (float max)
void | setAvg (float avg)
void | setDev (float dev)
template<typename T >
void | setOrigin (const T &ijk)

## Static Public Member Functions
static constexpr int64_t | memUsage ()
static constexpr uint32_t | padding ()
static constexpr uint8_t | bitWidth ()
static bool | hasStats ()

## Public Attributes
uint8_t | mCode [1u<< 3 *LOG2DIM]
CoordT | mBBoxMin
uint8_t | mBBoxDif [3]
uint8_t | mFlags
MaskT< LOG2DIM > | mValueMask
float | mMinimum
float | mQuantum
uint16_t | mMin
uint16_t | mMax
uint16_t | mAvg
uint16_t | mDev

## Static Public Attributes
static constexpr bool | FIXED_SIZE = true

## Member Typedef Documentation

## ◆ ArrayType

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

using ArrayType = uint8_t

## ◆ BaseT

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

using BaseT = LeafFnBase<CoordT, MaskT, LOG2DIM>

## ◆ BuildType

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

using BuildType = Fp8

## ◆ FloatType

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

using FloatType = float
| inherited

## ◆ ValueType

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

using ValueType = float
| inherited

## Constructor & Destructor Documentation

## ◆ LeafData() [1/2]

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData | ( |  | ) |
| delete

This class cannot be constructed or deleted.

## ◆ LeafData() [2/2]

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData | ( | const LeafData< Fp8, CoordT, MaskT, LOG2DIM > & |  | ) |
| delete

## ◆ ~LeafData()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

~LeafData | ( |  | ) |
| delete

## Member Function Documentation

## ◆ bitWidth()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

static constexpr uint8_t bitWidth | ( |  | ) |
| inline static constexpr

## ◆ getAvg()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

float getAvg | ( |  | ) | const
| inline inherited

return the quantized average of the active values in this node

## ◆ getDev()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

float getDev | ( |  | ) | const
| inline inherited

return the quantized standard deviation of the active values in this node

Note
  0 <= StdDev <= max-min or 0 <= StdDev/(max-min) <= 1

## ◆ getMax()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

float getMax | ( |  | ) | const
| inline inherited

return the quantized maximum of the active values in this node

## ◆ getMin()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

float getMin | ( |  | ) | const
| inline inherited

return the quantized minimum of the active values in this node

## ◆ getValue()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

float getValue | ( | uint32_t | i | ) | const
| inline

## ◆ hasStats()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

static bool hasStats | ( |  | ) |
| inline static inherited

## ◆ init()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

void init | ( | float | min,
|  | float | max,
|  | uint8_t | bitWidth )
| inline inherited

## ◆ memUsage()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

static constexpr int64_t memUsage | ( |  | ) |
| inline static constexpr

## ◆ operator=()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData & operator= | ( | const LeafData< Fp8, CoordT, MaskT, LOG2DIM > & |  | ) |
| delete

## ◆ padding()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

static constexpr uint32_t padding | ( |  | ) |
| inline static constexpr

## ◆ setAvg()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setAvg | ( | float | avg | ) |
| inline inherited

Note
  min <= avg <= max or 0 <= (avg-min)/(min-max) <= 1

## ◆ setDev()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setDev | ( | float | dev | ) |
| inline inherited

Note
  0 <= StdDev <= max-min or 0 <= StdDev/(max-min) <= 1

## ◆ setMax()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setMax | ( | float | max | ) |
| inline inherited

Note
  min <= X <= max or 0 <= (X-min)/(min-max) <= 1

## ◆ setMin()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setMin | ( | float | min | ) |
| inline inherited

Note
  min <= X <= max or 0 <= (X-min)/(min-max) <= 1

## ◆ setOn()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setOn | ( | uint32_t | offset | ) |
| inline inherited

## ◆ setOrigin()

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>
template<typename T >

void setOrigin | ( | const T & | ijk | ) |
| inline inherited

## Member Data Documentation

## ◆ FIXED_SIZE

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

bool FIXED_SIZE = true
| static constexpr

## ◆ mAvg

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint16_t mAvg
| inherited

## ◆ mBBoxDif

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint8_t mBBoxDif[3]
| inherited

## ◆ mBBoxMin

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

CoordT mBBoxMin
| inherited

## ◆ mCode

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint8_t mCode[1u<< 3 *LOG2DIM]

## ◆ mDev

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint16_t mDev
| inherited

## ◆ mFlags

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint8_t mFlags
| inherited

## ◆ mMax

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint16_t mMax
| inherited

## ◆ mMin

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint16_t mMin
| inherited

## ◆ mMinimum

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

float mMinimum
| inherited

## ◆ mQuantum

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

float mQuantum
| inherited

## ◆ mValueMask

template<typename CoordT , template< uint32_t > class MaskT, uint32_t LOG2DIM>

MaskT<LOG2DIM> mValueMask
| inherited